// TaskPlot.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "TaskPlotWnd.h"
#include "RealTimePlot.h"
#include "TaskPlot.h"

/*
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif CTempWnd
*/

TaskPlotWnd *g_TaskWnd;
int bUseDlg = 0;

TASKPLOT_API BOOL CreateTaskPlot(CWnd *parent)
{
//	TRACE("Application instance handle is 0x%0X\n", AfxGetInstanceHandle());
	TaskPlotWnd *TaskWnd = new TaskPlotWnd;
	CRect rc;
//    TRACE("Application instance handle is 0x%0X\n", AfxGetInstanceHandle());
	parent->GetWindowRect(&rc);
	CRect rcDraw(0, 0, rc.right-rc.left-4, rc.bottom-rc.top-4);

	TaskWnd->Create(0,"title",WS_VISIBLE|WS_HSCROLL|WS_VSCROLL, rcDraw, parent,0);
//TRACE("Application instance handle is 0x%0X\n", AfxGetInstanceHandle());
	CWnd *pWnd = TaskWnd->GetParent();
	CFrameWnd *frame = TaskWnd->GetParentFrame();

//	TaskWnd->
	g_TaskWnd = TaskWnd;
	
	return 1;
}

TASKPLOT_API BOOL ShowTaskPlot(int p_index)
{
	g_TaskWnd->m_Graph.m_curproc = p_index;
	g_TaskWnd->OnUpdate(NULL,0,NULL);
	g_TaskWnd->OnViewSetScaleToFit();
	return 1;
}

TASKPLOT_API BOOL InsertTaskPlot(int p_index,char *name,double period, double deadline, double wcet, double start_offset, int prio)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	if(g_TaskWnd)
	{
		g_TaskWnd->m_Graph.AddChannel(p_index, name, prio, period, deadline, wcet, start_offset);
	}
	
	if((p_index+1) > g_TaskWnd->m_Graph.m_maxproc)
	{
		g_TaskWnd->m_Graph.m_maxproc = p_index + 1;
	}

	return 1;
}

TASKPLOT_API BOOL ClearTaskPlot(int pindex)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	if(g_TaskWnd)
	{
		g_TaskWnd->m_Graph.RemoveAll(pindex);
	}
	return 1;
}

/*
If max_time_to_show is 0, LCM value of all task periods will be used.
scheduling_policy : 0=PRIORITY_GIVEN_INCREASE_ORDER, 1=RMA, 2=DM
*/
TASKPLOT_API BOOL ReadyTaskPlot(int pindex, int scheduling_policy)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	double max_time_to_show = 0;
	if(g_TaskWnd)
	{
		if(g_TaskWnd->m_Graph.m_procs.Sort(pindex, scheduling_policy)==false)
			return 0;

		if(g_TaskWnd->m_Graph.InitComplete(pindex, max_time_to_show)==false)
			return 0;

		g_TaskWnd->m_bInitDone[pindex] = 1;
	}
	return 1;
}

TASKPLOT_API BOOL DrawTaskPlot(CDC *dc)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	if(g_TaskWnd)
	{
		g_TaskWnd->OnDraw(dc);
	}
	return 1;
}

TASKPLOT_API BOOL ZoomTaskPlot(int ratio)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	if(g_TaskWnd)
	{
		if(ratio == 1)		g_TaskWnd->OnViewZoomIn();
		else if(ratio == -1)g_TaskWnd->OnViewZoomOut();
		else if(ratio == 0)	g_TaskWnd->OnViewSetScaleToFit();//OnViewZoomDefault();
	}
	return 1;
}
