// cpp source file AIF.cpp generated from diagram AIF
// generated on Sat Jul 05 05:52:24 2003
#include "stdafx.h"
#include "AIF_CORBA.h"
#include "UmlExt.h"

namespace AIF_CORBA {

	Uml::Diagram umldiagram;

	Uml::Class SubscribePort::meta;
	Uml::Class CallOut::meta;
	Uml::Class Interactions::meta;
	Uml::Class TimerComponent::meta;
	Uml::Class Method::meta;
	Uml::Class Action::meta;
	Uml::Class InvocationQoSProperties::meta;
	Uml::Class AIFObject::meta;
	Uml::Class TriggerQoSProperties::meta;
	Uml::Class InvocationConnection::meta;
	Uml::Class PublishPort::meta;
	Uml::Class ComponentInstance::meta;
	Uml::Class Event::meta;
	Uml::Class ComponentMode::meta;
	Uml::Class ModeTransition::meta;
	Uml::Class Interface::meta;
	Uml::Class EventPort::meta;
	Uml::Class System::meta;
	Uml::Class ApplicationComponent::meta;
	Uml::Class Receptacle::meta;
	Uml::Class SupportComponent::meta;
	Uml::Class Facet::meta;
	Uml::Class BackupComponent::meta;
	Uml::Class SystemMode::meta;
	Uml::Class Component::meta;
	Uml::Class Processor::meta;
	Uml::Class CommPort::meta;
	Uml::Class Link::meta;
	Uml::Class Process::meta;
	Uml::Class Thread::meta;
	Uml::Class NormalComponent::meta;
	Uml::Class Network::meta;
	Uml::Attribute SubscribePort::meta_asynchronous;
	Uml::Attribute SubscribePort::meta_correlation;
	Uml::Attribute TimerComponent::meta_period;
	Uml::Attribute Method::meta_dataSize;
	Uml::Attribute Action::meta_WCET;
	Uml::Attribute InvocationQoSProperties::meta_requiredPeriod;
	Uml::Attribute InvocationQoSProperties::meta_aggregateWCET;
	Uml::Attribute InvocationQoSProperties::meta_expectedPeriod;
	Uml::Attribute InvocationQoSProperties::meta_deadline;
	Uml::Attribute InvocationQoSProperties::meta_priority;
	Uml::Attribute InvocationQoSProperties::meta_importance;
	Uml::Attribute AIFObject::meta_guid;
	Uml::Attribute AIFObject::meta_name;
	Uml::Attribute AIFObject::meta_creator;
	Uml::Attribute AIFObject::meta_creationDate;
	Uml::Attribute AIFObject::meta_lastModifier;
	Uml::Attribute AIFObject::meta_lastModDate;
	Uml::Attribute AIFObject::meta_locked;
	Uml::Attribute AIFObject::meta_locker;
	Uml::Attribute TriggerQoSProperties::meta_requiredPeriod;
	Uml::Attribute TriggerQoSProperties::meta_aggregateWCET;
	Uml::Attribute TriggerQoSProperties::meta_expectedPeriod;
	Uml::Attribute TriggerQoSProperties::meta_deadline;
	Uml::Attribute TriggerQoSProperties::meta_priority;
	Uml::Attribute TriggerQoSProperties::meta_importance;
	Uml::Attribute InvocationConnection::meta_asynchronous;
	Uml::Attribute ComponentInstance::meta_groupID;
	Uml::Attribute ComponentInstance::meta_itemID;
	Uml::Attribute ComponentMode::meta_initialMode;
	Uml::Attribute System::meta_timeUnit;
	Uml::Attribute Facet::meta_distributableWrite;
	Uml::Attribute Facet::meta_distributableRead;
	Uml::Attribute SystemMode::meta_faultMode;
	Uml::Attribute Processor::meta_id;
	Uml::AssociationRole SubscribePort::meta_src;
	Uml::AssociationRole SubscribePort::meta_action, SubscribePort::meta_action_rev;
	Uml::AssociationRole SubscribePort::meta_modes;
	Uml::AssociationRole SubscribePort::meta_CommPort;
	Uml::AssociationRole CallOut::meta_method;
	Uml::AssociationRole CallOut::meta_receptacle;
	Uml::AssociationRole CallOut::meta_action;
	Uml::AssociationRole Interactions::meta_SystemMode;
	Uml::AssociationRole Interactions::meta_componentInstances;
	Uml::AssociationRole TimerComponent::meta_event;
	Uml::AssociationRole Method::meta_co;
	Uml::AssociationRole Method::meta_iqos;
	Uml::AssociationRole Action::meta_trigger, Action::meta_trigger_rev;
	Uml::AssociationRole Action::meta_co;
	Uml::AssociationRole Action::meta_port;
	Uml::AssociationRole Action::meta_iqos;
	Uml::AssociationRole Action::meta_modes;
	Uml::AssociationRole InvocationQoSProperties::meta_method;
	Uml::AssociationRole InvocationQoSProperties::meta_action;
	Uml::AssociationRole InvocationQoSProperties::meta_facet;
	Uml::AssociationRole InvocationQoSProperties::meta_owner;
	Uml::AssociationRole TriggerQoSProperties::meta_owner;
	Uml::AssociationRole TriggerQoSProperties::meta_trigger_end_;
	Uml::AssociationRole TriggerQoSProperties::meta_action_end_;
	Uml::AssociationRole InvocationConnection::meta_implements;
	Uml::AssociationRole InvocationConnection::meta_callout_end_;
	Uml::AssociationRole InvocationConnection::meta_invokes_end_;
	Uml::AssociationRole PublishPort::meta_generatesEventsFor;
	Uml::AssociationRole PublishPort::meta_event;
	Uml::AssociationRole PublishPort::meta_modes;
	Uml::AssociationRole PublishPort::meta_CommPort;
	Uml::AssociationRole ComponentInstance::meta_interactions;
	Uml::AssociationRole ComponentInstance::meta_owner, ComponentInstance::meta_owner_rev;
	Uml::AssociationRole Event::meta_dst;
	Uml::AssociationRole Event::meta_timer;
	Uml::AssociationRole Event::meta_publish;
	Uml::AssociationRole ComponentMode::meta_subscribePorts;
	Uml::AssociationRole ComponentMode::meta_actions;
	Uml::AssociationRole ComponentMode::meta_publishPorts;
	Uml::AssociationRole ComponentMode::meta_dst, ComponentMode::meta_dst_rev;
	Uml::AssociationRole ComponentMode::meta_facets;
	Uml::AssociationRole ComponentMode::meta_receptacles;
	Uml::AssociationRole ComponentMode::meta_src, ComponentMode::meta_src_rev;
	Uml::AssociationRole ModeTransition::meta_src_end_;
	Uml::AssociationRole ModeTransition::meta_dst_end_;
	Uml::AssociationRole Interface::meta_receptacles;
	Uml::AssociationRole Interface::meta_implementedBy;
	Uml::AssociationRole ApplicationComponent::meta_proxy;
	Uml::AssociationRole Receptacle::meta_co;
	Uml::AssociationRole Receptacle::meta_modes;
	Uml::AssociationRole Receptacle::meta_theInterface;
	Uml::AssociationRole Receptacle::meta_invokes, Receptacle::meta_invokes_rev;
	Uml::AssociationRole SupportComponent::meta_master;
	Uml::AssociationRole Facet::meta_iqos;
	Uml::AssociationRole Facet::meta_modes;
	Uml::AssociationRole Facet::meta_theInterface;
	Uml::AssociationRole Facet::meta_callout, Facet::meta_callout_rev;
	Uml::AssociationRole SystemMode::meta_Interactions;
	Uml::AssociationRole Component::meta_dst_end_;
	Uml::AssociationRole Component::meta_owner_end_;
	Uml::AssociationRole CommPort::meta_subscriber;
	Uml::AssociationRole CommPort::meta_publisher;
	Uml::AssociationRole CommPort::meta_dst, CommPort::meta_dst_rev;
	Uml::AssociationRole CommPort::meta_src, CommPort::meta_src_rev;
	Uml::AssociationRole Link::meta_invocationConns;
	Uml::AssociationRole Link::meta_src_end_;
	Uml::AssociationRole Link::meta_dst_end_;
	Uml::AssociationRole Process::meta_dst, Process::meta_dst_rev;
	Uml::AssociationRole Thread::meta_iQoSProp;
	Uml::AssociationRole Thread::meta_tQoSProp;
	Uml::CompositionParentRole CallOut::meta_ComponentInstance_parent;
	Uml::CompositionParentRole Interactions::meta_System_parent;
	Uml::CompositionParentRole TimerComponent::meta_Interactions_parent;
	Uml::CompositionParentRole Method::meta_Interface_parent;
	Uml::CompositionParentRole Action::meta_ComponentInstance_parent;
	Uml::CompositionParentRole InvocationQoSProperties::meta_ComponentInstance_parent;
	Uml::CompositionParentRole TriggerQoSProperties::meta_ComponentInstance_parent;
	Uml::CompositionParentRole InvocationConnection::meta_Interactions_parent;
	Uml::CompositionParentRole ComponentInstance::meta_Processor_parent;
	Uml::CompositionParentRole Event::meta_Interactions_parent;
	Uml::CompositionParentRole ComponentMode::meta_ComponentInstance_parent;
	Uml::CompositionParentRole ModeTransition::meta_ComponentInstance_parent;
	Uml::CompositionParentRole Interface::meta_System_parent;
	Uml::CompositionParentRole EventPort::meta_ComponentInstance_parent;
	Uml::CompositionParentRole Receptacle::meta_ComponentInstance_parent;
	Uml::CompositionParentRole Facet::meta_ComponentInstance_parent;
	Uml::CompositionParentRole SystemMode::meta_Processor_parent;
	Uml::CompositionParentRole Component::meta_Process_parent;
	Uml::CompositionParentRole Processor::meta_Network_parent;
	Uml::CompositionParentRole CommPort::meta_Processor_parent;
	Uml::CompositionParentRole Link::meta_Network_parent;
	Uml::CompositionParentRole Process::meta_Processor_parent;
	Uml::CompositionParentRole Thread::meta_Process_parent;
	Uml::CompositionParentRole Network::meta_System_parent;
	Uml::CompositionChildRole Interactions::meta_Event_children;
	Uml::CompositionChildRole Interactions::meta_TimerComponent_children;
	Uml::CompositionChildRole Interactions::meta_InvocationConnection_children;
	Uml::CompositionChildRole ComponentInstance::meta_InvocationQoSProperties_children;
	Uml::CompositionChildRole ComponentInstance::meta_TriggerQoSProperties_children;
	Uml::CompositionChildRole ComponentInstance::meta_Action_children;
	Uml::CompositionChildRole ComponentInstance::meta_ComponentMode_children;
	Uml::CompositionChildRole ComponentInstance::meta_EventPort_children;
	Uml::CompositionChildRole ComponentInstance::meta_ModeTransition_children;
	Uml::CompositionChildRole ComponentInstance::meta_Facet_children;
	Uml::CompositionChildRole ComponentInstance::meta_Receptacle_children;
	Uml::CompositionChildRole ComponentInstance::meta_CallOut_children;
	Uml::CompositionChildRole Interface::meta_Method_children;
	Uml::CompositionChildRole System::meta_Interactions_children;
	Uml::CompositionChildRole System::meta_Network_children;
	Uml::CompositionChildRole System::meta_Interface_children;
	Uml::CompositionChildRole Processor::meta_Process_children;
	Uml::CompositionChildRole Processor::meta_ComponentInstance_children;
	Uml::CompositionChildRole Processor::meta_SystemMode_children;
	Uml::CompositionChildRole Processor::meta_CommPort_children;
	Uml::CompositionChildRole Process::meta_Component_children;
	Uml::CompositionChildRole Process::meta_Thread_children;
	Uml::CompositionChildRole Network::meta_Processor_children;
	Uml::CompositionChildRole Network::meta_Link_children;
	void Initialize()
	{
		static bool first = true;
		if(!first) return;
		first = false;
		Uml::Initialize();

		ASSERT( umldiagram == Udm::null );
		umldiagram = Uml::CreateCORBADiagram();

		SubscribePort::meta = Uml::CreateCORBAClass();
		CallOut::meta = Uml::CreateCORBAClass();
		Interactions::meta = Uml::CreateCORBAClass();
		TimerComponent::meta = Uml::CreateCORBAClass();
		Method::meta = Uml::CreateCORBAClass();
		Action::meta = Uml::CreateCORBAClass();
		InvocationQoSProperties::meta = Uml::CreateCORBAClass();
		AIFObject::meta = Uml::CreateCORBAClass();
		TriggerQoSProperties::meta = Uml::CreateCORBAClass();
		InvocationConnection::meta = Uml::CreateCORBAClass();
		PublishPort::meta = Uml::CreateCORBAClass();
		ComponentInstance::meta = Uml::CreateCORBAClass();
		Event::meta = Uml::CreateCORBAClass();
		ComponentMode::meta = Uml::CreateCORBAClass();
		ModeTransition::meta = Uml::CreateCORBAClass();
		Interface::meta = Uml::CreateCORBAClass();
		EventPort::meta = Uml::CreateCORBAClass();
		System::meta = Uml::CreateCORBAClass();
		ApplicationComponent::meta = Uml::CreateCORBAClass();
		Receptacle::meta = Uml::CreateCORBAClass();
		SupportComponent::meta = Uml::CreateCORBAClass();
		Facet::meta = Uml::CreateCORBAClass();
		BackupComponent::meta = Uml::CreateCORBAClass();
		SystemMode::meta = Uml::CreateCORBAClass();
		Component::meta = Uml::CreateCORBAClass();
		Processor::meta = Uml::CreateCORBAClass();
		CommPort::meta = Uml::CreateCORBAClass();
		Link::meta = Uml::CreateCORBAClass();
		Process::meta = Uml::CreateCORBAClass();
		Thread::meta = Uml::CreateCORBAClass();
		NormalComponent::meta = Uml::CreateCORBAClass();
		Network::meta = Uml::CreateCORBAClass();
		SubscribePort::meta_asynchronous = Uml::CreateCORBAAttribute();
		SubscribePort::meta_correlation = Uml::CreateCORBAAttribute();
		TimerComponent::meta_period = Uml::CreateCORBAAttribute();
		Method::meta_dataSize = Uml::CreateCORBAAttribute();
		Action::meta_WCET = Uml::CreateCORBAAttribute();
		InvocationQoSProperties::meta_requiredPeriod = Uml::CreateCORBAAttribute();
		InvocationQoSProperties::meta_aggregateWCET = Uml::CreateCORBAAttribute();
		InvocationQoSProperties::meta_expectedPeriod = Uml::CreateCORBAAttribute();
		InvocationQoSProperties::meta_deadline = Uml::CreateCORBAAttribute();
		InvocationQoSProperties::meta_priority = Uml::CreateCORBAAttribute();
		InvocationQoSProperties::meta_importance = Uml::CreateCORBAAttribute();
		AIFObject::meta_guid = Uml::CreateCORBAAttribute();
		AIFObject::meta_name = Uml::CreateCORBAAttribute();
		AIFObject::meta_creator = Uml::CreateCORBAAttribute();
		AIFObject::meta_creationDate = Uml::CreateCORBAAttribute();
		AIFObject::meta_lastModifier = Uml::CreateCORBAAttribute();
		AIFObject::meta_lastModDate = Uml::CreateCORBAAttribute();
		AIFObject::meta_locked = Uml::CreateCORBAAttribute();
		AIFObject::meta_locker = Uml::CreateCORBAAttribute();
		TriggerQoSProperties::meta_requiredPeriod = Uml::CreateCORBAAttribute();
		TriggerQoSProperties::meta_aggregateWCET = Uml::CreateCORBAAttribute();
		TriggerQoSProperties::meta_expectedPeriod = Uml::CreateCORBAAttribute();
		TriggerQoSProperties::meta_deadline = Uml::CreateCORBAAttribute();
		TriggerQoSProperties::meta_priority = Uml::CreateCORBAAttribute();
		TriggerQoSProperties::meta_importance = Uml::CreateCORBAAttribute();
		InvocationConnection::meta_asynchronous = Uml::CreateCORBAAttribute();
		ComponentInstance::meta_groupID = Uml::CreateCORBAAttribute();
		ComponentInstance::meta_itemID = Uml::CreateCORBAAttribute();
		ComponentMode::meta_initialMode = Uml::CreateCORBAAttribute();
		System::meta_timeUnit = Uml::CreateCORBAAttribute();
		Facet::meta_distributableWrite = Uml::CreateCORBAAttribute();
		Facet::meta_distributableRead = Uml::CreateCORBAAttribute();
		SystemMode::meta_faultMode = Uml::CreateCORBAAttribute();
		Processor::meta_id = Uml::CreateCORBAAttribute();
		SubscribePort::meta_src = Uml::CreateCORBAAssociationRole();
		SubscribePort::meta_action = Uml::CreateCORBAAssociationRole();
		SubscribePort::meta_modes = Uml::CreateCORBAAssociationRole();
		SubscribePort::meta_CommPort = Uml::CreateCORBAAssociationRole();
		CallOut::meta_method = Uml::CreateCORBAAssociationRole();
		CallOut::meta_receptacle = Uml::CreateCORBAAssociationRole();
		CallOut::meta_action = Uml::CreateCORBAAssociationRole();
		Interactions::meta_SystemMode = Uml::CreateCORBAAssociationRole();
		Interactions::meta_componentInstances = Uml::CreateCORBAAssociationRole();
		TimerComponent::meta_event = Uml::CreateCORBAAssociationRole();
		Method::meta_co = Uml::CreateCORBAAssociationRole();
		Method::meta_iqos = Uml::CreateCORBAAssociationRole();
		Action::meta_trigger = Uml::CreateCORBAAssociationRole();
		Action::meta_co = Uml::CreateCORBAAssociationRole();
		Action::meta_port = Uml::CreateCORBAAssociationRole();
		Action::meta_iqos = Uml::CreateCORBAAssociationRole();
		Action::meta_modes = Uml::CreateCORBAAssociationRole();
		InvocationQoSProperties::meta_method = Uml::CreateCORBAAssociationRole();
		InvocationQoSProperties::meta_action = Uml::CreateCORBAAssociationRole();
		InvocationQoSProperties::meta_facet = Uml::CreateCORBAAssociationRole();
		InvocationQoSProperties::meta_owner = Uml::CreateCORBAAssociationRole();
		TriggerQoSProperties::meta_owner = Uml::CreateCORBAAssociationRole();
		InvocationConnection::meta_implements = Uml::CreateCORBAAssociationRole();
		PublishPort::meta_generatesEventsFor = Uml::CreateCORBAAssociationRole();
		PublishPort::meta_event = Uml::CreateCORBAAssociationRole();
		PublishPort::meta_modes = Uml::CreateCORBAAssociationRole();
		PublishPort::meta_CommPort = Uml::CreateCORBAAssociationRole();
		ComponentInstance::meta_interactions = Uml::CreateCORBAAssociationRole();
		ComponentInstance::meta_owner = Uml::CreateCORBAAssociationRole();
		Event::meta_dst = Uml::CreateCORBAAssociationRole();
		Event::meta_timer = Uml::CreateCORBAAssociationRole();
		Event::meta_publish = Uml::CreateCORBAAssociationRole();
		ComponentMode::meta_subscribePorts = Uml::CreateCORBAAssociationRole();
		ComponentMode::meta_actions = Uml::CreateCORBAAssociationRole();
		ComponentMode::meta_publishPorts = Uml::CreateCORBAAssociationRole();
		ComponentMode::meta_dst = Uml::CreateCORBAAssociationRole();
		ComponentMode::meta_facets = Uml::CreateCORBAAssociationRole();
		ComponentMode::meta_receptacles = Uml::CreateCORBAAssociationRole();
		ComponentMode::meta_src = Uml::CreateCORBAAssociationRole();
		Interface::meta_receptacles = Uml::CreateCORBAAssociationRole();
		Interface::meta_implementedBy = Uml::CreateCORBAAssociationRole();
		ApplicationComponent::meta_proxy = Uml::CreateCORBAAssociationRole();
		Receptacle::meta_co = Uml::CreateCORBAAssociationRole();
		Receptacle::meta_modes = Uml::CreateCORBAAssociationRole();
		Receptacle::meta_theInterface = Uml::CreateCORBAAssociationRole();
		Receptacle::meta_invokes = Uml::CreateCORBAAssociationRole();
		SupportComponent::meta_master = Uml::CreateCORBAAssociationRole();
		Facet::meta_iqos = Uml::CreateCORBAAssociationRole();
		Facet::meta_modes = Uml::CreateCORBAAssociationRole();
		Facet::meta_theInterface = Uml::CreateCORBAAssociationRole();
		Facet::meta_callout = Uml::CreateCORBAAssociationRole();
		SystemMode::meta_Interactions = Uml::CreateCORBAAssociationRole();
		CommPort::meta_subscriber = Uml::CreateCORBAAssociationRole();
		CommPort::meta_publisher = Uml::CreateCORBAAssociationRole();
		CommPort::meta_dst = Uml::CreateCORBAAssociationRole();
		CommPort::meta_src = Uml::CreateCORBAAssociationRole();
		Link::meta_invocationConns = Uml::CreateCORBAAssociationRole();
		Process::meta_dst = Uml::CreateCORBAAssociationRole();
		Thread::meta_iQoSProp = Uml::CreateCORBAAssociationRole();
		Thread::meta_tQoSProp = Uml::CreateCORBAAssociationRole();
		CallOut::meta_ComponentInstance_parent = Uml::CreateCORBACompositionParentRole();
		Interactions::meta_System_parent = Uml::CreateCORBACompositionParentRole();
		TimerComponent::meta_Interactions_parent = Uml::CreateCORBACompositionParentRole();
		Method::meta_Interface_parent = Uml::CreateCORBACompositionParentRole();
		Action::meta_ComponentInstance_parent = Uml::CreateCORBACompositionParentRole();
		InvocationQoSProperties::meta_ComponentInstance_parent = Uml::CreateCORBACompositionParentRole();
		TriggerQoSProperties::meta_ComponentInstance_parent = Uml::CreateCORBACompositionParentRole();
		InvocationConnection::meta_Interactions_parent = Uml::CreateCORBACompositionParentRole();
		ComponentInstance::meta_Processor_parent = Uml::CreateCORBACompositionParentRole();
		Event::meta_Interactions_parent = Uml::CreateCORBACompositionParentRole();
		ComponentMode::meta_ComponentInstance_parent = Uml::CreateCORBACompositionParentRole();
		ModeTransition::meta_ComponentInstance_parent = Uml::CreateCORBACompositionParentRole();
		Interface::meta_System_parent = Uml::CreateCORBACompositionParentRole();
		EventPort::meta_ComponentInstance_parent = Uml::CreateCORBACompositionParentRole();
		Receptacle::meta_ComponentInstance_parent = Uml::CreateCORBACompositionParentRole();
		Facet::meta_ComponentInstance_parent = Uml::CreateCORBACompositionParentRole();
		SystemMode::meta_Processor_parent = Uml::CreateCORBACompositionParentRole();
		Component::meta_Process_parent = Uml::CreateCORBACompositionParentRole();
		Processor::meta_Network_parent = Uml::CreateCORBACompositionParentRole();
		CommPort::meta_Processor_parent = Uml::CreateCORBACompositionParentRole();
		Link::meta_Network_parent = Uml::CreateCORBACompositionParentRole();
		Process::meta_Processor_parent = Uml::CreateCORBACompositionParentRole();
		Thread::meta_Process_parent = Uml::CreateCORBACompositionParentRole();
		Network::meta_System_parent = Uml::CreateCORBACompositionParentRole();
		Interactions::meta_Event_children = Uml::CreateCORBACompositionChildRole();
		Interactions::meta_TimerComponent_children = Uml::CreateCORBACompositionChildRole();
		Interactions::meta_InvocationConnection_children = Uml::CreateCORBACompositionChildRole();
		ComponentInstance::meta_InvocationQoSProperties_children = Uml::CreateCORBACompositionChildRole();
		ComponentInstance::meta_TriggerQoSProperties_children = Uml::CreateCORBACompositionChildRole();
		ComponentInstance::meta_Action_children = Uml::CreateCORBACompositionChildRole();
		ComponentInstance::meta_ComponentMode_children = Uml::CreateCORBACompositionChildRole();
		ComponentInstance::meta_EventPort_children = Uml::CreateCORBACompositionChildRole();
		ComponentInstance::meta_ModeTransition_children = Uml::CreateCORBACompositionChildRole();
		ComponentInstance::meta_Facet_children = Uml::CreateCORBACompositionChildRole();
		ComponentInstance::meta_Receptacle_children = Uml::CreateCORBACompositionChildRole();
		ComponentInstance::meta_CallOut_children = Uml::CreateCORBACompositionChildRole();
		Interface::meta_Method_children = Uml::CreateCORBACompositionChildRole();
		System::meta_Interactions_children = Uml::CreateCORBACompositionChildRole();
		System::meta_Network_children = Uml::CreateCORBACompositionChildRole();
		System::meta_Interface_children = Uml::CreateCORBACompositionChildRole();
		Processor::meta_Process_children = Uml::CreateCORBACompositionChildRole();
		Processor::meta_ComponentInstance_children = Uml::CreateCORBACompositionChildRole();
		Processor::meta_SystemMode_children = Uml::CreateCORBACompositionChildRole();
		Processor::meta_CommPort_children = Uml::CreateCORBACompositionChildRole();
		Process::meta_Component_children = Uml::CreateCORBACompositionChildRole();
		Process::meta_Thread_children = Uml::CreateCORBACompositionChildRole();
		Network::meta_Processor_children = Uml::CreateCORBACompositionChildRole();
		Network::meta_Link_children = Uml::CreateCORBACompositionChildRole();
		Uml::InitCORBADiagram(umldiagram, "AIF");

		Uml::InitCORBAClass(SubscribePort::meta, umldiagram, "SubscribePort", false);
		Uml::InitCORBAClass(CallOut::meta, umldiagram, "CallOut", false);
		Uml::InitCORBAClass(Interactions::meta, umldiagram, "Interactions", false);
		Uml::InitCORBAClass(TimerComponent::meta, umldiagram, "TimerComponent", false);
		Uml::InitCORBAClass(Method::meta, umldiagram, "Method", false);
		Uml::InitCORBAClass(Action::meta, umldiagram, "Action", false);
		Uml::InitCORBAClass(InvocationQoSProperties::meta, umldiagram, "InvocationQoSProperties", false);
		Uml::InitCORBAClass(AIFObject::meta, umldiagram, "AIFObject", true);
		Uml::InitCORBAClass(TriggerQoSProperties::meta, umldiagram, "TriggerQoSProperties", false);
		Uml::InitCORBAClass(InvocationConnection::meta, umldiagram, "InvocationConnection", false);
		Uml::InitCORBAClass(PublishPort::meta, umldiagram, "PublishPort", false);
		Uml::InitCORBAClass(ComponentInstance::meta, umldiagram, "ComponentInstance", true);
		Uml::InitCORBAClass(Event::meta, umldiagram, "Event", false);
		Uml::InitCORBAClass(ComponentMode::meta, umldiagram, "ComponentMode", false);
		Uml::InitCORBAClass(ModeTransition::meta, umldiagram, "ModeTransition", false);
		Uml::InitCORBAClass(Interface::meta, umldiagram, "Interface", false);
		Uml::InitCORBAClass(EventPort::meta, umldiagram, "EventPort", true);
		Uml::InitCORBAClass(System::meta, umldiagram, "System", false);
		Uml::InitCORBAClass(ApplicationComponent::meta, umldiagram, "ApplicationComponent", false);
		Uml::InitCORBAClass(Receptacle::meta, umldiagram, "Receptacle", false);
		Uml::InitCORBAClass(SupportComponent::meta, umldiagram, "SupportComponent", false);
		Uml::InitCORBAClass(Facet::meta, umldiagram, "Facet", false);
		Uml::InitCORBAClass(BackupComponent::meta, umldiagram, "BackupComponent", false);
		Uml::InitCORBAClass(SystemMode::meta, umldiagram, "SystemMode", false);
		Uml::InitCORBAClass(Component::meta, umldiagram, "Component", true);
		Uml::InitCORBAClass(Processor::meta, umldiagram, "Processor", false);
		Uml::InitCORBAClass(CommPort::meta, umldiagram, "CommPort", false);
		Uml::InitCORBAClass(Link::meta, umldiagram, "Link", false);
		Uml::InitCORBAClass(Process::meta, umldiagram, "Process", false);
		Uml::InitCORBAClass(Thread::meta, umldiagram, "Thread", false);
		Uml::InitCORBAClass(NormalComponent::meta, umldiagram, "NormalComponent", false);
		Uml::InitCORBAClass(Network::meta, umldiagram, "Network", false);
		
		vector<string> SubscribePort_asynchronous_dva;
		Uml::InitCORBAAttribute(SubscribePort::meta_asynchronous, SubscribePort::meta, "asynchronous", "Boolean", false, 1, 1, false, "public", SubscribePort_asynchronous_dva);
		vector<string> SubscribePort_correlation_dva;
		Uml::InitCORBAAttribute(SubscribePort::meta_correlation, SubscribePort::meta, "correlation", "Boolean", false, 1, 1, false, "public", SubscribePort_correlation_dva);
		vector<string> TimerComponent_period_dva;
		Uml::InitCORBAAttribute(TimerComponent::meta_period, TimerComponent::meta, "period", "String", false, 1, 1, false, "public", TimerComponent_period_dva);
		vector<string> Method_dataSize_dva;
		Uml::InitCORBAAttribute(Method::meta_dataSize, Method::meta, "dataSize", "Integer", false, 1, 1, false, "public", Method_dataSize_dva);
		vector<string> Action_WCET_dva;
		Uml::InitCORBAAttribute(Action::meta_WCET, Action::meta, "WCET", "String", false, 1, 1, false, "public", Action_WCET_dva);
		vector<string> InvocationQoSProperties_requiredPeriod_dva;
		Uml::InitCORBAAttribute(InvocationQoSProperties::meta_requiredPeriod, InvocationQoSProperties::meta, "requiredPeriod", "String", false, 1, 1, false, "public", InvocationQoSProperties_requiredPeriod_dva);
		vector<string> InvocationQoSProperties_aggregateWCET_dva;
		Uml::InitCORBAAttribute(InvocationQoSProperties::meta_aggregateWCET, InvocationQoSProperties::meta, "aggregateWCET", "String", false, 1, 1, false, "public", InvocationQoSProperties_aggregateWCET_dva);
		vector<string> InvocationQoSProperties_expectedPeriod_dva;
		Uml::InitCORBAAttribute(InvocationQoSProperties::meta_expectedPeriod, InvocationQoSProperties::meta, "expectedPeriod", "String", false, 1, 1, false, "public", InvocationQoSProperties_expectedPeriod_dva);
		vector<string> InvocationQoSProperties_deadline_dva;
		Uml::InitCORBAAttribute(InvocationQoSProperties::meta_deadline, InvocationQoSProperties::meta, "deadline", "String", false, 1, 1, false, "public", InvocationQoSProperties_deadline_dva);
		vector<string> InvocationQoSProperties_priority_dva;
		Uml::InitCORBAAttribute(InvocationQoSProperties::meta_priority, InvocationQoSProperties::meta, "priority", "String", false, 1, 1, false, "public", InvocationQoSProperties_priority_dva);
		vector<string> InvocationQoSProperties_importance_dva;
		Uml::InitCORBAAttribute(InvocationQoSProperties::meta_importance, InvocationQoSProperties::meta, "importance", "String", false, 1, 1, false, "public", InvocationQoSProperties_importance_dva);
		vector<string> AIFObject_guid_dva;
		Uml::InitCORBAAttribute(AIFObject::meta_guid, AIFObject::meta, "guid", "String", false, 1, 1, false, "public", AIFObject_guid_dva);
		vector<string> AIFObject_name_dva;
		Uml::InitCORBAAttribute(AIFObject::meta_name, AIFObject::meta, "name", "String", false, 1, 1, false, "public", AIFObject_name_dva);
		vector<string> AIFObject_creator_dva;
		Uml::InitCORBAAttribute(AIFObject::meta_creator, AIFObject::meta, "creator", "String", false, 1, 1, false, "public", AIFObject_creator_dva);
		vector<string> AIFObject_creationDate_dva;
		Uml::InitCORBAAttribute(AIFObject::meta_creationDate, AIFObject::meta, "creationDate", "String", false, 1, 1, false, "public", AIFObject_creationDate_dva);
		vector<string> AIFObject_lastModifier_dva;
		Uml::InitCORBAAttribute(AIFObject::meta_lastModifier, AIFObject::meta, "lastModifier", "String", false, 1, 1, false, "public", AIFObject_lastModifier_dva);
		vector<string> AIFObject_lastModDate_dva;
		Uml::InitCORBAAttribute(AIFObject::meta_lastModDate, AIFObject::meta, "lastModDate", "String", false, 1, 1, false, "public", AIFObject_lastModDate_dva);
		vector<string> AIFObject_locked_dva;
		Uml::InitCORBAAttribute(AIFObject::meta_locked, AIFObject::meta, "locked", "Boolean", false, 1, 1, false, "public", AIFObject_locked_dva);
		vector<string> AIFObject_locker_dva;
		Uml::InitCORBAAttribute(AIFObject::meta_locker, AIFObject::meta, "locker", "String", false, 1, 1, false, "public", AIFObject_locker_dva);
		vector<string> TriggerQoSProperties_requiredPeriod_dva;
		Uml::InitCORBAAttribute(TriggerQoSProperties::meta_requiredPeriod, TriggerQoSProperties::meta, "requiredPeriod", "String", false, 1, 1, false, "public", TriggerQoSProperties_requiredPeriod_dva);
		vector<string> TriggerQoSProperties_aggregateWCET_dva;
		Uml::InitCORBAAttribute(TriggerQoSProperties::meta_aggregateWCET, TriggerQoSProperties::meta, "aggregateWCET", "String", false, 1, 1, false, "public", TriggerQoSProperties_aggregateWCET_dva);
		vector<string> TriggerQoSProperties_expectedPeriod_dva;
		Uml::InitCORBAAttribute(TriggerQoSProperties::meta_expectedPeriod, TriggerQoSProperties::meta, "expectedPeriod", "String", false, 1, 1, false, "public", TriggerQoSProperties_expectedPeriod_dva);
		vector<string> TriggerQoSProperties_deadline_dva;
		Uml::InitCORBAAttribute(TriggerQoSProperties::meta_deadline, TriggerQoSProperties::meta, "deadline", "String", false, 1, 1, false, "public", TriggerQoSProperties_deadline_dva);
		vector<string> TriggerQoSProperties_priority_dva;
		Uml::InitCORBAAttribute(TriggerQoSProperties::meta_priority, TriggerQoSProperties::meta, "priority", "String", false, 1, 1, false, "public", TriggerQoSProperties_priority_dva);
		vector<string> TriggerQoSProperties_importance_dva;
		Uml::InitCORBAAttribute(TriggerQoSProperties::meta_importance, TriggerQoSProperties::meta, "importance", "String", false, 1, 1, false, "public", TriggerQoSProperties_importance_dva);
		vector<string> InvocationConnection_asynchronous_dva;
		Uml::InitCORBAAttribute(InvocationConnection::meta_asynchronous, InvocationConnection::meta, "asynchronous", "Boolean", false, 1, 1, false, "public", InvocationConnection_asynchronous_dva);
		vector<string> ComponentInstance_groupID_dva;
		Uml::InitCORBAAttribute(ComponentInstance::meta_groupID, ComponentInstance::meta, "groupID", "Integer", false, 1, 1, false, "public", ComponentInstance_groupID_dva);
		vector<string> ComponentInstance_itemID_dva;
		Uml::InitCORBAAttribute(ComponentInstance::meta_itemID, ComponentInstance::meta, "itemID", "Integer", false, 1, 1, false, "public", ComponentInstance_itemID_dva);
		vector<string> ComponentMode_initialMode_dva;
		Uml::InitCORBAAttribute(ComponentMode::meta_initialMode, ComponentMode::meta, "initialMode", "Boolean", false, 1, 1, false, "public", ComponentMode_initialMode_dva);
		vector<string> System_timeUnit_dva;
		Uml::InitCORBAAttribute(System::meta_timeUnit, System::meta, "timeUnit", "String", false, 1, 1, false, "public", System_timeUnit_dva);
		vector<string> Facet_distributableWrite_dva;
		Uml::InitCORBAAttribute(Facet::meta_distributableWrite, Facet::meta, "distributableWrite", "Boolean", false, 1, 1, false, "public", Facet_distributableWrite_dva);
		vector<string> Facet_distributableRead_dva;
		Uml::InitCORBAAttribute(Facet::meta_distributableRead, Facet::meta, "distributableRead", "Boolean", false, 1, 1, false, "public", Facet_distributableRead_dva);
		vector<string> SystemMode_faultMode_dva;
		Uml::InitCORBAAttribute(SystemMode::meta_faultMode, SystemMode::meta, "faultMode", "Boolean", false, 1, 1, false, "public", SystemMode_faultMode_dva);
		vector<string> Processor_id_dva;
		Uml::InitCORBAAttribute(Processor::meta_id, Processor::meta, "id", "Integer", false, 1, 1, false, "public", Processor_id_dva);
		
		{
			Uml::Association ass = Uml::CreateCORBAAssociation();
			Uml::InitCORBAAssociation(ass , umldiagram, "");
			Uml::InitCORBAAssociationRole(SubscribePort::meta_src, ass, "src", true, false, 0, -1, Event::meta);
			Uml::InitCORBAAssociationRole(Event::meta_dst, ass, "dst", true, false, 0, -1, SubscribePort::meta);
		}
		{
			Uml::Association ass = Uml::CreateCORBAAssociation();
			Uml::InitCORBAAssociation(ass , umldiagram, "TriggerQoSProperties");
			Uml::InitCORBAAssociationClass(ass, TriggerQoSProperties::meta);
			Uml::InitCORBAAssociationRole(SubscribePort::meta_action, ass, "action", true, false, 0, -1, Action::meta);
			TriggerQoSProperties::meta_action_end_ = Action::meta_trigger_rev = SubscribePort::meta_action;
			Uml::InitCORBAAssociationRole(Action::meta_trigger, ass, "trigger", true, false, 0, -1, SubscribePort::meta);
			TriggerQoSProperties::meta_trigger_end_ = SubscribePort::meta_action_rev = Action::meta_trigger;
		}
		{
			Uml::Association ass = Uml::CreateCORBAAssociation();
			Uml::InitCORBAAssociation(ass , umldiagram, "");
			Uml::InitCORBAAssociationRole(SubscribePort::meta_modes, ass, "modes", true, false, 0, -1, ComponentMode::meta);
			Uml::InitCORBAAssociationRole(ComponentMode::meta_subscribePorts, ass, "subscribePorts", true, false, 0, -1, SubscribePort::meta);
		}
		{
			Uml::Association ass = Uml::CreateCORBAAssociation();
			Uml::InitCORBAAssociation(ass , umldiagram, "");
			Uml::InitCORBAAssociationRole(SubscribePort::meta_CommPort, ass, "CommPort", true, false, 0, 1, CommPort::meta);
			Uml::InitCORBAAssociationRole(CommPort::meta_subscriber, ass, "subscriber", true, false, 0, -1, SubscribePort::meta);
		}
		{
			Uml::Association ass = Uml::CreateCORBAAssociation();
			Uml::InitCORBAAssociation(ass , umldiagram, "");
			Uml::InitCORBAAssociationRole(CallOut::meta_method, ass, "method", true, false, 0, 1, Method::meta);
			Uml::InitCORBAAssociationRole(Method::meta_co, ass, "co", true, false, 0, -1, CallOut::meta);
		}
		{
			Uml::Association ass = Uml::CreateCORBAAssociation();
			Uml::InitCORBAAssociation(ass , umldiagram, "");
			Uml::InitCORBAAssociationRole(CallOut::meta_receptacle, ass, "receptacle", true, false, 0, 1, Receptacle::meta);
			Uml::InitCORBAAssociationRole(Receptacle::meta_co, ass, "co", true, false, 0, -1, CallOut::meta);
		}
		{
			Uml::Association ass = Uml::CreateCORBAAssociation();
			Uml::InitCORBAAssociation(ass , umldiagram, "");
			Uml::InitCORBAAssociationRole(CallOut::meta_action, ass, "action", true, false, 0, -1, Action::meta);
			Uml::InitCORBAAssociationRole(Action::meta_co, ass, "co", true, false, 0, -1, CallOut::meta);
		}
		{
			Uml::Association ass = Uml::CreateCORBAAssociation();
			Uml::InitCORBAAssociation(ass , umldiagram, "");
			Uml::InitCORBAAssociationRole(Interactions::meta_SystemMode, ass, "SystemMode", true, false, 1, -1, SystemMode::meta);
			Uml::InitCORBAAssociationRole(SystemMode::meta_Interactions, ass, "Interactions", true, false, 1, 1, Interactions::meta);
		}
		{
			Uml::Association ass = Uml::CreateCORBAAssociation();
			Uml::InitCORBAAssociation(ass , umldiagram, "");
			Uml::InitCORBAAssociationRole(Interactions::meta_componentInstances, ass, "componentInstances", true, false, 0, -1, ComponentInstance::meta);
			Uml::InitCORBAAssociationRole(ComponentInstance::meta_interactions, ass, "interactions", true, false, 0, -1, Interactions::meta);
		}
		{
			Uml::Association ass = Uml::CreateCORBAAssociation();
			Uml::InitCORBAAssociation(ass , umldiagram, "");
			Uml::InitCORBAAssociationRole(Event::meta_timer, ass, "timer", true, false, 0, 1, TimerComponent::meta);
			Uml::InitCORBAAssociationRole(TimerComponent::meta_event, ass, "event", true, false, 0, -1, Event::meta);
		}
		{
			Uml::Association ass = Uml::CreateCORBAAssociation();
			Uml::InitCORBAAssociation(ass , umldiagram, "");
			Uml::InitCORBAAssociationRole(Method::meta_iqos, ass, "iqos", true, false, 0, -1, InvocationQoSProperties::meta);
			Uml::InitCORBAAssociationRole(InvocationQoSProperties::meta_method, ass, "method", true, false, 0, 1, Method::meta);
		}
		{
			Uml::Association ass = Uml::CreateCORBAAssociation();
			Uml::InitCORBAAssociation(ass , umldiagram, "");
			Uml::InitCORBAAssociationRole(Action::meta_port, ass, "port", true, false, 0, -1, PublishPort::meta);
			Uml::InitCORBAAssociationRole(PublishPort::meta_generatesEventsFor, ass, "generatesEventsFor", true, false, 0, -1, Action::meta);
		}
		{
			Uml::Association ass = Uml::CreateCORBAAssociation();
			Uml::InitCORBAAssociation(ass , umldiagram, "");
			Uml::InitCORBAAssociationRole(Action::meta_iqos, ass, "iqos", true, false, 0, 1, InvocationQoSProperties::meta);
			Uml::InitCORBAAssociationRole(InvocationQoSProperties::meta_action, ass, "action", true, false, 0, 1, Action::meta);
		}
		{
			Uml::Association ass = Uml::CreateCORBAAssociation();
			Uml::InitCORBAAssociation(ass , umldiagram, "");
			Uml::InitCORBAAssociationRole(Action::meta_modes, ass, "modes", true, false, 0, -1, ComponentMode::meta);
			Uml::InitCORBAAssociationRole(ComponentMode::meta_actions, ass, "actions", true, false, 0, -1, Action::meta);
		}
		{
			Uml::Association ass = Uml::CreateCORBAAssociation();
			Uml::InitCORBAAssociation(ass , umldiagram, "");
			Uml::InitCORBAAssociationRole(InvocationQoSProperties::meta_facet, ass, "facet", true, false, 0, 1, Facet::meta);
			Uml::InitCORBAAssociationRole(Facet::meta_iqos, ass, "iqos", true, false, 0, -1, InvocationQoSProperties::meta);
		}
		{
			Uml::Association ass = Uml::CreateCORBAAssociation();
			Uml::InitCORBAAssociation(ass , umldiagram, "");
			Uml::InitCORBAAssociationRole(InvocationQoSProperties::meta_owner, ass, "owner", true, false, 0, 1, Thread::meta);
			Uml::InitCORBAAssociationRole(Thread::meta_iQoSProp, ass, "iQoSProp", true, false, 0, -1, InvocationQoSProperties::meta);
		}
		{
			Uml::Association ass = Uml::CreateCORBAAssociation();
			Uml::InitCORBAAssociation(ass , umldiagram, "");
			Uml::InitCORBAAssociationRole(TriggerQoSProperties::meta_owner, ass, "owner", true, false, 0, 1, Thread::meta);
			Uml::InitCORBAAssociationRole(Thread::meta_tQoSProp, ass, "tQoSProp", true, false, 0, -1, TriggerQoSProperties::meta);
		}
		{
			Uml::Association ass = Uml::CreateCORBAAssociation();
			Uml::InitCORBAAssociation(ass , umldiagram, "");
			Uml::InitCORBAAssociationRole(InvocationConnection::meta_implements, ass, "implements", true, false, 0, 1, Link::meta);
			Uml::InitCORBAAssociationRole(Link::meta_invocationConns, ass, "invocationConns", true, false, 0, -1, InvocationConnection::meta);
		}
		{
			Uml::Association ass = Uml::CreateCORBAAssociation();
			Uml::InitCORBAAssociation(ass , umldiagram, "");
			Uml::InitCORBAAssociationRole(PublishPort::meta_event, ass, "event", true, false, 0, -1, Event::meta);
			Uml::InitCORBAAssociationRole(Event::meta_publish, ass, "publish", true, false, 0, 1, PublishPort::meta);
		}
		{
			Uml::Association ass = Uml::CreateCORBAAssociation();
			Uml::InitCORBAAssociation(ass , umldiagram, "");
			Uml::InitCORBAAssociationRole(PublishPort::meta_modes, ass, "modes", true, false, 0, -1, ComponentMode::meta);
			Uml::InitCORBAAssociationRole(ComponentMode::meta_publishPorts, ass, "publishPorts", true, false, 0, -1, PublishPort::meta);
		}
		{
			Uml::Association ass = Uml::CreateCORBAAssociation();
			Uml::InitCORBAAssociation(ass , umldiagram, "");
			Uml::InitCORBAAssociationRole(PublishPort::meta_CommPort, ass, "CommPort", true, false, 0, 1, CommPort::meta);
			Uml::InitCORBAAssociationRole(CommPort::meta_publisher, ass, "publisher", true, false, 0, -1, PublishPort::meta);
		}
		{
			Uml::Association ass = Uml::CreateCORBAAssociation();
			Uml::InitCORBAAssociation(ass , umldiagram, "Component");
			Uml::InitCORBAAssociationClass(ass, Component::meta);
			Uml::InitCORBAAssociationRole(ComponentInstance::meta_owner, ass, "owner", true, false, 1, 1, Process::meta);
			Component::meta_owner_end_ = Process::meta_dst_rev = ComponentInstance::meta_owner;
			Uml::InitCORBAAssociationRole(Process::meta_dst, ass, "dst", true, false, 0, -1, ComponentInstance::meta);
			Component::meta_dst_end_ = ComponentInstance::meta_owner_rev = Process::meta_dst;
		}
		{
			Uml::Association ass = Uml::CreateCORBAAssociation();
			Uml::InitCORBAAssociation(ass , umldiagram, "ModeTransition");
			Uml::InitCORBAAssociationClass(ass, ModeTransition::meta);
			Uml::InitCORBAAssociationRole(ComponentMode::meta_dst, ass, "dst", true, false, 0, -1, ComponentMode::meta);
			ModeTransition::meta_dst_end_ = ComponentMode::meta_src_rev = ComponentMode::meta_dst;
			Uml::InitCORBAAssociationRole(ComponentMode::meta_src, ass, "src", true, false, 0, -1, ComponentMode::meta);
			ModeTransition::meta_src_end_ = ComponentMode::meta_dst_rev = ComponentMode::meta_src;
		}
		{
			Uml::Association ass = Uml::CreateCORBAAssociation();
			Uml::InitCORBAAssociation(ass , umldiagram, "");
			Uml::InitCORBAAssociationRole(ComponentMode::meta_facets, ass, "facets", true, false, 0, -1, Facet::meta);
			Uml::InitCORBAAssociationRole(Facet::meta_modes, ass, "modes", true, false, 0, 1, ComponentMode::meta);
		}
		{
			Uml::Association ass = Uml::CreateCORBAAssociation();
			Uml::InitCORBAAssociation(ass , umldiagram, "");
			Uml::InitCORBAAssociationRole(ComponentMode::meta_receptacles, ass, "receptacles", true, false, 0, -1, Receptacle::meta);
			Uml::InitCORBAAssociationRole(Receptacle::meta_modes, ass, "modes", true, false, 0, -1, ComponentMode::meta);
		}
		{
			Uml::Association ass = Uml::CreateCORBAAssociation();
			Uml::InitCORBAAssociation(ass , umldiagram, "");
			Uml::InitCORBAAssociationRole(Interface::meta_receptacles, ass, "receptacles", true, false, 0, -1, Receptacle::meta);
			Uml::InitCORBAAssociationRole(Receptacle::meta_theInterface, ass, "theInterface", true, false, 1, 1, Interface::meta);
		}
		{
			Uml::Association ass = Uml::CreateCORBAAssociation();
			Uml::InitCORBAAssociation(ass , umldiagram, "");
			Uml::InitCORBAAssociationRole(Interface::meta_implementedBy, ass, "implementedBy", true, false, 0, -1, Facet::meta);
			Uml::InitCORBAAssociationRole(Facet::meta_theInterface, ass, "theInterface", true, false, 1, 1, Interface::meta);
		}
		{
			Uml::Association ass = Uml::CreateCORBAAssociation();
			Uml::InitCORBAAssociation(ass , umldiagram, "");
			Uml::InitCORBAAssociationRole(ApplicationComponent::meta_proxy, ass, "proxy", true, false, 0, -1, SupportComponent::meta);
			Uml::InitCORBAAssociationRole(SupportComponent::meta_master, ass, "master", true, false, 1, 1, ApplicationComponent::meta);
		}
		{
			Uml::Association ass = Uml::CreateCORBAAssociation();
			Uml::InitCORBAAssociation(ass , umldiagram, "InvocationConnection");
			Uml::InitCORBAAssociationClass(ass, InvocationConnection::meta);
			Uml::InitCORBAAssociationRole(Receptacle::meta_invokes, ass, "invokes", true, false, 0, -1, Facet::meta);
			InvocationConnection::meta_invokes_end_ = Facet::meta_callout_rev = Receptacle::meta_invokes;
			Uml::InitCORBAAssociationRole(Facet::meta_callout, ass, "callout", true, false, 0, -1, Receptacle::meta);
			InvocationConnection::meta_callout_end_ = Receptacle::meta_invokes_rev = Facet::meta_callout;
		}
		{
			Uml::Association ass = Uml::CreateCORBAAssociation();
			Uml::InitCORBAAssociation(ass , umldiagram, "Link");
			Uml::InitCORBAAssociationClass(ass, Link::meta);
			Uml::InitCORBAAssociationRole(CommPort::meta_dst, ass, "dst", true, false, 0, -1, CommPort::meta);
			Link::meta_dst_end_ = CommPort::meta_src_rev = CommPort::meta_dst;
			Uml::InitCORBAAssociationRole(CommPort::meta_src, ass, "src", true, false, 0, -1, CommPort::meta);
			Link::meta_src_end_ = CommPort::meta_dst_rev = CommPort::meta_src;
		}
		{
			Uml::Composition comp = Uml::CreateCORBAComposition();
			Uml::InitCORBAComposition(comp , umldiagram, "");
		
			Uml::InitCORBACompositionParentRole(Event::meta_Interactions_parent, comp, "Interactions_parent", true, Interactions::meta);
			Uml::InitCORBACompositionChildRole(Interactions::meta_Event_children, comp, "Event", true, 0, -1, Event::meta);
		}
		{
			Uml::Composition comp = Uml::CreateCORBAComposition();
			Uml::InitCORBAComposition(comp , umldiagram, "");
		
			Uml::InitCORBACompositionParentRole(TimerComponent::meta_Interactions_parent, comp, "Interactions_parent", true, Interactions::meta);
			Uml::InitCORBACompositionChildRole(Interactions::meta_TimerComponent_children, comp, "TimerComponent", true, 0, -1, TimerComponent::meta);
		}
		{
			Uml::Composition comp = Uml::CreateCORBAComposition();
			Uml::InitCORBAComposition(comp , umldiagram, "");
		
			Uml::InitCORBACompositionParentRole(InvocationConnection::meta_Interactions_parent, comp, "Interactions_parent", true, Interactions::meta);
			Uml::InitCORBACompositionChildRole(Interactions::meta_InvocationConnection_children, comp, "InvocationConnection", true, 0, -1, InvocationConnection::meta);
		}
		{
			Uml::Composition comp = Uml::CreateCORBAComposition();
			Uml::InitCORBAComposition(comp , umldiagram, "");
		
			Uml::InitCORBACompositionParentRole(InvocationQoSProperties::meta_ComponentInstance_parent, comp, "ComponentInstance_parent", true, ComponentInstance::meta);
			Uml::InitCORBACompositionChildRole(ComponentInstance::meta_InvocationQoSProperties_children, comp, "InvocationQoSProperties", true, 0, -1, InvocationQoSProperties::meta);
		}
		{
			Uml::Composition comp = Uml::CreateCORBAComposition();
			Uml::InitCORBAComposition(comp , umldiagram, "");
		
			Uml::InitCORBACompositionParentRole(TriggerQoSProperties::meta_ComponentInstance_parent, comp, "ComponentInstance_parent", true, ComponentInstance::meta);
			Uml::InitCORBACompositionChildRole(ComponentInstance::meta_TriggerQoSProperties_children, comp, "TriggerQoSProperties", true, 0, -1, TriggerQoSProperties::meta);
		}
		{
			Uml::Composition comp = Uml::CreateCORBAComposition();
			Uml::InitCORBAComposition(comp , umldiagram, "");
		
			Uml::InitCORBACompositionParentRole(Action::meta_ComponentInstance_parent, comp, "ComponentInstance_parent", true, ComponentInstance::meta);
			Uml::InitCORBACompositionChildRole(ComponentInstance::meta_Action_children, comp, "Action", true, 0, -1, Action::meta);
		}
		{
			Uml::Composition comp = Uml::CreateCORBAComposition();
			Uml::InitCORBAComposition(comp , umldiagram, "");
		
			Uml::InitCORBACompositionParentRole(ComponentMode::meta_ComponentInstance_parent, comp, "ComponentInstance_parent", true, ComponentInstance::meta);
			Uml::InitCORBACompositionChildRole(ComponentInstance::meta_ComponentMode_children, comp, "ComponentMode", true, 0, -1, ComponentMode::meta);
		}
		{
			Uml::Composition comp = Uml::CreateCORBAComposition();
			Uml::InitCORBAComposition(comp , umldiagram, "");
		
			Uml::InitCORBACompositionParentRole(EventPort::meta_ComponentInstance_parent, comp, "ComponentInstance_parent", true, ComponentInstance::meta);
			Uml::InitCORBACompositionChildRole(ComponentInstance::meta_EventPort_children, comp, "EventPort", true, 0, -1, EventPort::meta);
		}
		{
			Uml::Composition comp = Uml::CreateCORBAComposition();
			Uml::InitCORBAComposition(comp , umldiagram, "");
		
			Uml::InitCORBACompositionParentRole(ModeTransition::meta_ComponentInstance_parent, comp, "ComponentInstance_parent", true, ComponentInstance::meta);
			Uml::InitCORBACompositionChildRole(ComponentInstance::meta_ModeTransition_children, comp, "ModeTransition", true, 0, -1, ModeTransition::meta);
		}
		{
			Uml::Composition comp = Uml::CreateCORBAComposition();
			Uml::InitCORBAComposition(comp , umldiagram, "");
		
			Uml::InitCORBACompositionParentRole(Facet::meta_ComponentInstance_parent, comp, "ComponentInstance_parent", true, ComponentInstance::meta);
			Uml::InitCORBACompositionChildRole(ComponentInstance::meta_Facet_children, comp, "Facet", true, 0, -1, Facet::meta);
		}
		{
			Uml::Composition comp = Uml::CreateCORBAComposition();
			Uml::InitCORBAComposition(comp , umldiagram, "");
		
			Uml::InitCORBACompositionParentRole(Receptacle::meta_ComponentInstance_parent, comp, "ComponentInstance_parent", true, ComponentInstance::meta);
			Uml::InitCORBACompositionChildRole(ComponentInstance::meta_Receptacle_children, comp, "Receptacle", true, 0, -1, Receptacle::meta);
		}
		{
			Uml::Composition comp = Uml::CreateCORBAComposition();
			Uml::InitCORBAComposition(comp , umldiagram, "");
		
			Uml::InitCORBACompositionParentRole(CallOut::meta_ComponentInstance_parent, comp, "ComponentInstance_parent", true, ComponentInstance::meta);
			Uml::InitCORBACompositionChildRole(ComponentInstance::meta_CallOut_children, comp, "CallOut", true, 0, -1, CallOut::meta);
		}
		{
			Uml::Composition comp = Uml::CreateCORBAComposition();
			Uml::InitCORBAComposition(comp , umldiagram, "");
		
			Uml::InitCORBACompositionParentRole(Method::meta_Interface_parent, comp, "Interface_parent", true, Interface::meta);
			Uml::InitCORBACompositionChildRole(Interface::meta_Method_children, comp, "Method", true, 0, -1, Method::meta);
		}
		{
			Uml::Composition comp = Uml::CreateCORBAComposition();
			Uml::InitCORBAComposition(comp , umldiagram, "");
		
			Uml::InitCORBACompositionParentRole(Interactions::meta_System_parent, comp, "System_parent", true, System::meta);
			Uml::InitCORBACompositionChildRole(System::meta_Interactions_children, comp, "Interactions", true, 0, -1, Interactions::meta);
		}
		{
			Uml::Composition comp = Uml::CreateCORBAComposition();
			Uml::InitCORBAComposition(comp , umldiagram, "");
		
			Uml::InitCORBACompositionParentRole(Network::meta_System_parent, comp, "System_parent", true, System::meta);
			Uml::InitCORBACompositionChildRole(System::meta_Network_children, comp, "Network", true, 0, -1, Network::meta);
		}
		{
			Uml::Composition comp = Uml::CreateCORBAComposition();
			Uml::InitCORBAComposition(comp , umldiagram, "");
		
			Uml::InitCORBACompositionParentRole(Interface::meta_System_parent, comp, "System_parent", true, System::meta);
			Uml::InitCORBACompositionChildRole(System::meta_Interface_children, comp, "Interface", true, 0, -1, Interface::meta);
		}
		{
			Uml::Composition comp = Uml::CreateCORBAComposition();
			Uml::InitCORBAComposition(comp , umldiagram, "");
		
			Uml::InitCORBACompositionParentRole(Process::meta_Processor_parent, comp, "Processor_parent", true, Processor::meta);
			Uml::InitCORBACompositionChildRole(Processor::meta_Process_children, comp, "Process", true, 1, -1, Process::meta);
		}
		{
			Uml::Composition comp = Uml::CreateCORBAComposition();
			Uml::InitCORBAComposition(comp , umldiagram, "");
		
			Uml::InitCORBACompositionParentRole(ComponentInstance::meta_Processor_parent, comp, "Processor_parent", true, Processor::meta);
			Uml::InitCORBACompositionChildRole(Processor::meta_ComponentInstance_children, comp, "ComponentInstance", true, 0, -1, ComponentInstance::meta);
		}
		{
			Uml::Composition comp = Uml::CreateCORBAComposition();
			Uml::InitCORBAComposition(comp , umldiagram, "");
		
			Uml::InitCORBACompositionParentRole(SystemMode::meta_Processor_parent, comp, "Processor_parent", true, Processor::meta);
			Uml::InitCORBACompositionChildRole(Processor::meta_SystemMode_children, comp, "SystemMode", true, 0, -1, SystemMode::meta);
		}
		{
			Uml::Composition comp = Uml::CreateCORBAComposition();
			Uml::InitCORBAComposition(comp , umldiagram, "");
		
			Uml::InitCORBACompositionParentRole(CommPort::meta_Processor_parent, comp, "Processor_parent", true, Processor::meta);
			Uml::InitCORBACompositionChildRole(Processor::meta_CommPort_children, comp, "CommPort", true, 0, -1, CommPort::meta);
		}
		{
			Uml::Composition comp = Uml::CreateCORBAComposition();
			Uml::InitCORBAComposition(comp , umldiagram, "");
		
			Uml::InitCORBACompositionParentRole(Component::meta_Process_parent, comp, "Process_parent", true, Process::meta);
			Uml::InitCORBACompositionChildRole(Process::meta_Component_children, comp, "Component", true, 0, -1, Component::meta);
		}
		{
			Uml::Composition comp = Uml::CreateCORBAComposition();
			Uml::InitCORBAComposition(comp , umldiagram, "");
		
			Uml::InitCORBACompositionParentRole(Thread::meta_Process_parent, comp, "Process_parent", true, Process::meta);
			Uml::InitCORBACompositionChildRole(Process::meta_Thread_children, comp, "Thread", true, 0, -1, Thread::meta);
		}
		{
			Uml::Composition comp = Uml::CreateCORBAComposition();
			Uml::InitCORBAComposition(comp , umldiagram, "");
		
			Uml::InitCORBACompositionParentRole(Processor::meta_Network_parent, comp, "Network_parent", true, Network::meta);
			Uml::InitCORBACompositionChildRole(Network::meta_Processor_children, comp, "Processor", true, 0, -1, Processor::meta);
		}
		{
			Uml::Composition comp = Uml::CreateCORBAComposition();
			Uml::InitCORBAComposition(comp , umldiagram, "");
		
			Uml::InitCORBACompositionParentRole(Link::meta_Network_parent, comp, "Network_parent", true, Network::meta);
			Uml::InitCORBACompositionChildRole(Network::meta_Link_children, comp, "Link", true, 0, -1, Link::meta);
		}
		Uml::AddCORBAInheritance(AIFObject::meta, CallOut::meta);
		Uml::AddCORBAInheritance(AIFObject::meta, Interactions::meta);
		Uml::AddCORBAInheritance(AIFObject::meta, TimerComponent::meta);
		Uml::AddCORBAInheritance(AIFObject::meta, Method::meta);
		Uml::AddCORBAInheritance(AIFObject::meta, Action::meta);
		Uml::AddCORBAInheritance(AIFObject::meta, InvocationQoSProperties::meta);
		Uml::AddCORBAInheritance(AIFObject::meta, TriggerQoSProperties::meta);
		Uml::AddCORBAInheritance(AIFObject::meta, InvocationConnection::meta);
		Uml::AddCORBAInheritance(AIFObject::meta, ComponentInstance::meta);
		Uml::AddCORBAInheritance(AIFObject::meta, Event::meta);
		Uml::AddCORBAInheritance(AIFObject::meta, ComponentMode::meta);
		Uml::AddCORBAInheritance(AIFObject::meta, ModeTransition::meta);
		Uml::AddCORBAInheritance(AIFObject::meta, Interface::meta);
		Uml::AddCORBAInheritance(AIFObject::meta, EventPort::meta);
		Uml::AddCORBAInheritance(AIFObject::meta, Receptacle::meta);
		Uml::AddCORBAInheritance(AIFObject::meta, Facet::meta);
		Uml::AddCORBAInheritance(AIFObject::meta, SystemMode::meta);
		Uml::AddCORBAInheritance(AIFObject::meta, Component::meta);
		Uml::AddCORBAInheritance(AIFObject::meta, Processor::meta);
		Uml::AddCORBAInheritance(AIFObject::meta, CommPort::meta);
		Uml::AddCORBAInheritance(AIFObject::meta, Link::meta);
		Uml::AddCORBAInheritance(AIFObject::meta, Process::meta);
		Uml::AddCORBAInheritance(AIFObject::meta, Thread::meta);
		Uml::AddCORBAInheritance(AIFObject::meta, Network::meta);
		Uml::AddCORBAInheritance(ComponentInstance::meta, ApplicationComponent::meta);
		Uml::AddCORBAInheritance(ComponentInstance::meta, SupportComponent::meta);
		Uml::AddCORBAInheritance(EventPort::meta, SubscribePort::meta);
		Uml::AddCORBAInheritance(EventPort::meta, PublishPort::meta);
		Uml::AddCORBAInheritance(Component::meta, BackupComponent::meta);
		Uml::AddCORBAInheritance(Component::meta, NormalComponent::meta);
		
	}
	Udm::UdmDiagram diagram = { &umldiagram, Initialize };
}
// END AIF.cpp
