#if !defined(AFX_MYLISTVIEW_H__5E2A7936_19E7_11D6_8EB9_00010235688C__INCLUDED_)
#define AFX_MYLISTVIEW_H__5E2A7936_19E7_11D6_8EB9_00010235688C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MyListView.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CMyListView view
#include "AIFRead.h"
#include "MultiColumnSortListView.h"

class CMyListView : public CMultiColumnSortListView
{
protected:
	CMyListView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CMyListView)

// Attributes
public:

// Operations
public:
	void DisplayProcessors();
	//void DisplayTaskChains();
	void DisplayTasks(CProcessorNode *pNode);
	void DisplayComponentPorts(const CPortNodeList &ports);
	void DisplayPortDetails(CPortNode *pNode);
	void DisplayComponents(CProcessorNode *pNode);
	void DisplayComponentDetails(CComponentNode *cNode);
	
	BOOL AddColumn( LPCTSTR column_name,
                   int     column_number,
                   int     width    = (-1),
                   int     nSubItem = (-1),
                   int     mask = LVCF_FMT  | LVCF_WIDTH |
                                  LVCF_TEXT | LVCF_SUBITEM,
                   int     format = LVCFMT_LEFT );

   int AddItem( int     row_number,
                 int     column_number,
                 LPCTSTR text,
                 int     image_index = (-1) );

   void Empty( void );
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMyListView)
	protected:
	virtual void OnDraw(CDC* pDC);      // overridden to draw this view
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CMyListView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
protected:
	//{{AFX_MSG(CMyListView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDblclk(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MYLISTVIEW_H__5E2A7936_19E7_11D6_8EB9_00010235688C__INCLUDED_)
